# This file is part of FatxFast.
#
#    FatxFast is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    FatxFast is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with FatxFast.  If not, see <http://www.gnu.org/licenses/>.

# Versioning based on: 
# http://en.wikipedia.org/wiki/Versioning#Designating_development_stage
__author__ = "dryatu (c) 2013"
__version__ = "1.2.0"

import xml.etree.ElementTree as ET
from FatxFast.resource import resource_manager

class XmlParser(object):
    
    def __init__(self, filename):  
        fullpath = resource_manager.get_resource_path(filename)
        self.tree = ET.parse(fullpath)
        self.root = self.tree.getroot()
         
    def _get_attributes(self, node):
        keywords = {}
        for atr in node.attrib:
            attribute_value = node.attrib[atr]
            try:
                attribute_value = int(node.attrib[atr])
            except ValueError:
                pass
            keywords[atr] = attribute_value
        return keywords
